<div align="center">
  <h1>RoVector3</h1>
</div>

This package is a JS implementation of Roblox's Vector3 Class.

<h2 align="center">Install</h2>

```bash
npm install rovector3 --save
```

<h2 align="center">Usage</h2>

Once you've installed the package you can simply add it to your code:
```js
const CFrame = require('rovector3');
```

The great part about this package is that it functions similarly to Roblox's. However, since JS does not support operator overloading there are methods built into Vector3s as substitutes.

##### Addition
```js
const Vector3 = require('rovector3');

let a = Vector3.new(0,0,0);
let b = a.add(Vector3.new(5,0,0));
```

##### Subtraction
```js
const Vector3 = require('rovector3');

let a = Vector3.new(0,0,0);
let b = a.sub(Vector3.new(5,0,0));
```

##### Multiplication
```js
const Vector3 = require('rovector3');

let a = Vector3.new(0,0,0);
let b = a.mult(Vector3.new(5,0,0));
```

##### Division
```js
const Vector3 = require('rovector3');

let a = Vector3.new(0,0,0);
let b = a.div(Vector3.new(5,0,0));
```

##### Dot Product
```js
const Vector3 = require('rovector3');

let a = Vector3.new(3,2,1);
let b = a.Dot(Vector3.new(5,0,0));
```

##### Cross Product
```js
const Vector3 = require('rovector3');

let a = Vector3.new(5,12,2);
let b = a.Cross(Vector3.new(5,0,0));
```

##### Interpolation
```js
const Vector3 = require('rovector3');

let a = Vector3.new(0,0,0);
let b = a.Lerp(Vector3.new(5,0,0),0.75);
```

##### Unit
```js
const Vector3 = require('rovector3');

let a = Vector3.new(90,2,4).unit();
```
